INIT   ; INIT/ASM
 PGMEND	EQU	$		;end of program
 DBFF	EQU	$&0FF00H
 PRBUFF	EQU	DBFF+100H
 DAMBUFF	EQU	PRBUFF+400H
 GATBUFF	EQU	DAMBUFF+100H
 BUFFER	EQU	GATBUFF+100H
 BUFF1	EQU	BUFFER+100H
 FBUFF	EQU	BUFFER+1200H	;format buffer
 LBUFF	EQU	FBUFF+700H
 WHEREBUY	RST	8
 	DB	'11500 Stemmons Fwy - Suite 125 / Dallas, Texas  75229',10
 	DB	'Pre-Release Test Copy !!!  Not for sale or distribution !!!',10
 	DB	'Release #2 - Assembled January 27, 1982',0
 	RET
 START	DI			;turn 'em off
 	IM	1		;set interrupt type
 	LD	SP,STACK	;set stack area
 ;i*
 	IF	MODI
 	LD	A,0D0H
 	LD	(37ECH),A
 	ENDIF
 ;
 ;iii*
 	IF	MODIII
 	XOR	A
 	OUT	(0E4H),A
 	LD	A,4
 	OUT	(0E0H),A
 	LD	A,20H
 	OUT	(0ECH),A
 	LD	A,0D0H
 	OUT	(0F0H),A
 	ENDIF
 	LD	HL,DISPLY
 	LD	(4001H),HL
 	LD	HL,0E6F8H
 	LD	DE,SERSAVE
 	PUSH	DE
 	LD	BC,7
 	LDIR
 	LD	A,(0E6F7H)
 	LD	(SERCHECK),A
 	JP	RETURN
 INITBACK	CALL	IFCLEAR
 	JR	C,ERFGH
 	LD	HL,HELLOMSG
 	LD	DE,3C00H+320+18
 	LD	BC,26
 	LDIR
 ERFGH	LD	A,0D0H		;master reset FDC
 ;i*
 	IF	MODI
 	LD	(37ECH),A
 	ENDIF
 ;iii*
 	IF	MODIII
 	OUT	(0F0H),A
 	ENDIF
 ;
 	LD	HL,0
 	LD	(TOPMEM),HL
 	LD	DE,GATBUFF	;low buffer area
 	OR	A		;clear carry
 	SBC	HL,DE		;get length of buffer
 	OR	A		;clear again
 	RR	H		;divide in 2
 	RRC	L		;now have length of 1/2
 	ADD	HL,DE		;have a middle buffer
 	INC	H		;make it one page higher
 	LD	(MIDBUFF),HL	;save this
 	LD	HL,3FFFH
 	LD	E,(HL)
 	LD	A,60H
 	LD	(HL),A
 	CP	(HL)
 	LD	(HL),E
 	JR	NZ,INITKKK
 	LD	A,(FLAGA)
 	SET	0,A
 	LD	(FLAGA),A
 INITKKK	XOR	A
 	CALL	SETDRV
 	CALL	IFCLEAR
 	JP	C,DOLOAD
 	LD	DE,0101H
 	LD	BC,LBUFF
 	CALL	READ
 	JP	NZ,INITCONTXX
 	IF	MODI
 	LD	HL,LBUFF+50H
 	ENDIF
 	IF	MODIII
 	LD	HL,LBUFF+0B0H
 	ENDIF
 	LD	DE,0400H
 PUTTYP	LD	A,E
 	CALL	SETDRV
 	LD	(PAS8HL),HL
 	OR	A
 	CALL	GETTYPEB
 	RES	7,A
 	RES	4,A
 	SCF
 	CALL	GETTYPEB
 	LD	A,(HL)
 	CP	'='
 	JR	Z,INTBX
 	CP	'+'
 	JR	Z,INTA
 	CP	'-'
 	JR	NZ,INTA
 	OR	A
 	CALL	GETTYPEB
 	SET	7,A
 INTCX	SCF
 	CALL	GETTYPEB
 	JR	INTA
 INTBX	OR	A
 	CALL	GETTYPEB
 	SET	4,A
 	JR	INTCX
 INTA	INC	HL
 	INC	HL
 	LD	A,(HL)
 	CALL	CKCONF
 	JR	NZ,NEXTTYP
 	CALL	DENSELSET
 NEXTTYP	INC	HL
 	INC	HL
 	CALL	VALUE
 	SCF
 	CALL	GETTKS
 	CALL	VALUE
 	SCF
 	CALL	GETDIR
 	CALL	VALUE
 	AND	3
 	LD	B,A
 	OR	A
 	CALL	GETTYPEB
 	AND	0FCH
 	OR	B
 	SCF
 	CALL	GETTYPEB
 	CALL	VALUE
 	AND	1
 	LD	B,A
 	OR	A
 	CALL	GETTYPEB
 	AND	0BFH
 	SLA	B
 	SLA	B
 	SLA	B
 	SLA	B
 	SLA	B
 	OR	B
 	SCF
 	CALL	GETTYPEB
 	CALL	POSHL
 	OR	A
 	CALL	GETTYPEB
 	RES	6,A
 	SCF
 	CALL	GETTYPEB
 	LD	A,(HL)
 	CALL	UCASE
 	CP	'N'
 	JR	Z,NNTTYYP
 	CP	'Y'
 	JR	NZ,NNTTYYP
 	OR	A
 	CALL	GETTYPEB
 	SET	6,A
 	SCF
 	CALL	GETTYPEB
 NNTTYYP	INC	E
 	LD	HL,0
 PAS8HL	EQU	$-2
 	LD	A,L
 	ADD	A,16
 	LD	L,A
 	DEC	D
 	JP	NZ,PUTTYP
 INITCONTXX	LD	HL,DRVSAVE
 	LD	DE,SAVEDRV
 	LD	BC,16
 	LDIR
 	LD	A,3
 	LD	(TYPEB),A
 	XOR	A
 	LD	(TYPEA),A
 	CALL	SETDRV
 	LD	DE,0102H
 	LD	BC,LBUFF
 	CALL	READ
 	JP	NZ,UU88
 	LD	A,(FLAGA)
 	RES	4,A
 	LD	(FLAGA),A
 	IF	MODI
 	LD	A,(LBUFF+6FH)
 	ENDIF
 	IF	MODIII
 	LD	A,(LBUFF+0EFH)
 	ENDIF
 	CALL	UCASE
 	CALL	CHP
 	JR	C,SHPCHP2
 	LD	A,(FLAGA)
 	SET	4,A
 	LD	(FLAGA),A
 SHPCHP2
 	IF	MODI
 	LD	A,(LBUFF+3FH)
 	ENDIF
 	IF	MODIII
 	LD	A,(LBUFF+0AFH)
 	ENDIF
 	CALL	CHP
 	LD	A,(FLAGA)
 	RES	6,A
 	JR	C,UU66
 	SET	6,A
 UU66	LD	(FLAGA),A
 	IF	MODI
 	LD	A,(LBUFF+6FH)
 	ENDIF
 	IF	MODIII
 	LD	A,(LBUFF+0DFH)
 	ENDIF
 	CALL	CHP
 	LD	A,(FLAGA)
 	RES	5,A
 	JR	C,U981
 	SET	5,A
 U981	LD	(FLAGA),A
 	LD	DE,0D48H
 	LD	(TEMP1),DE
 	LD	IY,SPEEDON
 	IF	MODI
 	LD	HL,LBUFF+44H
 	ENDIF
 	IF	MODIII
 	LD	HL,LBUFF+0B4H
 	ENDIF
 	CALL	FIXSPEED
 	LD	IY,SPEEDOFF
 	IF	MODI
 	LD	HL,LBUFF+54H
 	ENDIF
 	IF	MODIII
 	LD	HL,LBUFF+0C4H
 	ENDIF
 	CALL	FIXSPEED
 	CALL	TURNSPEED
 	LD	A,13
 	IF	MODI
 	LD	(LBUFF+90H),A
 	ENDIF
 	IF	MODIII
 	LD	(LBUFF+100H),A
 	ENDIF
 	IF	MODI
 	LD	HL,LBUFF+8EH
 	ENDIF
 	IF	MODIII
 	LD	HL,LBUFF+0FEH
 	ENDIF
 	CALL	VALUE
 	LD	(DEFALTBASE),A
 UU88	LD	DE,0103H
 	LD	BC,LBUFF
 	CALL	READ
 	JP	NZ,INITCONTYY
 	LD	IX,FLAGB
 	LD	(IX),0
 	IF	MODI
 	LD	A,(LBUFF+4FH)
 	ENDIF
 	IF	MODIII
 	LD	A,(LBUFF+0BFH)
 	ENDIF
 	CALL	CHP
 	JR	C,UU11
 	SET	7,(IX)
 UU11
 	IF	MODI
 	LD	A,(LBUFF+5FH)
 	ENDIF
 	IF	MODIII
 	LD	A,(LBUFF+0CFH)
 	ENDIF
 	CALL	CHP
 	JR	C,UU22
 	SET	6,(IX)
 UU22
 	IF	MODI
 	LD	A,(LBUFF+6FH)
 	ENDIF
 	IF	MODIII
 	LD	A,(LBUFF+0DFH)
 	ENDIF
 	CALL	CHP
 	JR	C,UU33
 	SET	5,(IX)
 UU33
 	IF	MODI
 	LD	A,(LBUFF+8FH)
 	ENDIF
 	IF	MODIII
 	LD	A,(LBUFF+0FFH)
 	ENDIF
 	CALL	CHP
 	JR	C,UU44
 	SET	3,(IX)
 UU44
 	IF	MODI
 	LD	A,(LBUFF+7FH)
 	ENDIF
 	IF	MODIII
 	LD	A,(LBUFF+0EFH)
 	ENDIF
 	CALL	CHP
 	JR	NC,INITCONTYY
 	SET	4,(IX)
 INITCONTYY	XOR	A
 	CALL	SETDRV
 	IF	MODI
 	XOR	A
 	LD	(TYPEA),A
 	LD	DE,0006H
 	ENDIF
 	IF	MODIII
 	LD	A,8CH
 	LD	(TYPEA),A
 	LD	DE,0007H
 	ENDIF
 	LD	BC,LBUFF
 	CALL	READ
 	JR	NZ,SKPDBXX
 	LD	HL,LBUFF
 	LD	DE,KIMBOOT
 	LD	BC,100H
 	LDIR
 SKPDBXX
 	IF	MODI
 	LD	DE,0008H
 	ENDIF
 	IF	MODIII
 	LD	DE,0009H
 	ENDIF
 	LD	BC,LBUFF
 	CALL	READ
 	JR	NZ,SKPDB
 	LD	HL,LBUFF
 	LD	DE,KIMBOOT3
 	LD	BC,100H
 	LDIR
 SKPDB	XOR	A
 	CALL	SETDRV
 	LD	(TYPEA),A
 	IF	MODI
 	LD	DE,0105H
 	ENDIF
 	IF	MODIII
 	LD	DE,0205H
 	ENDIF
 	LD	BC,LBUFF
 	CALL	READ
 	JR	NZ,DOLOAD
 	LD	IX,LBUFF+47H
 	LD	B,12
 	LD	DE,16
 DODOT	LD	(IX+3),13
 	LD	(IX+9),13
 	ADD	IX,DE
 	DJNZ	DODOT
 	LD	B,12
 	LD	IY,LBUFF+47H
 	LD	DE,16
 DODOY	PUSH	IY
 	POP	HL
 	PUSH	IY
 	PUSH	BC
 	CALL	VALUE
 	POP	BC
 	LD	C,A
 	POP	IY
 	JR	C,DOLOADX
 	PUSH	IY
 	POP	HL
 	LD	A,L
 	ADD	A,6
 	LD	L,A
 	PUSH	IY
 	PUSH	BC
 	CALL	VALUE
 	POP	BC
 	POP	IY
 	JR	C,DOLOADX
 	OUT	(C),A
 DOLOADX	ADD	IY,DE
 	DJNZ	DODOY
 	IF	MODI
 	LD	DE,0104H
 	ENDIF
 	IF	MODIII
 	LD	DE,0204H
 	ENDIF
 	LD	BC,LBUFF
 	CALL	READ
 	JR	NZ,DOLOAD
 	LD	HL,LBUFF+0C0H
 	LD	DE,SPATTERN
 	LD	BC,16
 	PUSH	BC
 	LDIR
 	POP	BC
 	LD	HL,LBUFF+0E0H
 	LD	DE,DPATTERN
 	LDIR
 	LD	HL,LBUFF+68H
 	LD	DE,FMTNAME
 	LD	BC,8
 	LDIR
 	LD	DE,FMTDATE
 	LD	BC,8
 	LD	HL,LBUFF+78H
 	LDIR
 DOLOAD	LD	HL,MENU00
 	LD	(TEMP0),HL
 	CALL	IFCLEAR
 	CALL	NC,LOADDOIT
 ;i*
 	IF	MODI
 	XOR	A
 	LD	(37E4H),A
 	ENDIF
 ;
 	LD	HL,3C00H
 	LD	DE,3C01H
 	LD	BC,1023
 	LD	(HL),191
 	LDIR
 	LD	DE,DRVSAVE
 	LD	HL,SAVEDRV
 	LD	BC,16
 	LDIR
 	LD	BC,1800H
 	CALL	DELAY
 	XOR	A
 	CALL	SETUPS
 	LD	A,(3840H)	;check for arrows
 	AND	60H		;any pressed?
 	EI
 	JP	NZ,LOCATIONS	;display locations
 	LD	HL,(TEMP0)
 	JP	(HL)
 CHP	CALL	UCASE
 	CP	'Y'
 	RET	Z
 	SCF
 	RET
 HELLOMSG	DB	'* C O N F I G U R I N G * '
 LOADDOIT	XOR	A
 	CALL	SETDRV
 	IF	MODI
 	LD	DE,0106H
 	ENDIF
 	IF	MODIII
 	LD	DE,0206H
 	ENDIF
 	LD	BC,LBUFF
 	LD	L,4
 LODDY	PUSH	HL
 	CALL	READ
 	POP	HL
 	RET	NZ
 	INC	E
 	DEC	L
 	JR	NZ,LODDY
 	XOR	A
 	LD	(BC),A
 	LD	HL,LBUFF
 LODDE	LD	A,(HL)
 	INC	HL
 	OR	A
 	RET	Z
 	CP	1
 	JR	Z,LDDY1
 	CP	2
 	JR	Z,LDDY2
 	LD	B,(HL)
 	INC	HL
 LDDY3	INC	HL
 	DJNZ	LDDY3
 	JR	LODDE
 LDDY1	LD	B,(HL)
 	INC	HL
 	LD	E,(HL)
 	INC	HL
 	LD	D,(HL)
 	INC	HL
 	DEC	B
 	DEC	B
 LDDY1A	LD	A,(HL)
 	LD	(DE),A
 	INC	DE
 	INC	HL
 	DJNZ	LDDY1A
 	JR	LODDE
 LDDY2	INC	HL
 	LD	E,(HL)
 	INC	HL
 	LD	D,(HL)
 	INC	HL
 	LD	(TEMP0),DE
 	JR	LODDE
	INC	HL
 	DEC	B
 	DEC	B
 LDDY1A	LD	A,(HL)
 	LD	(DE),A
 	INC	DE
 	INC	HL
 	DJNZ	LDDY1A
 	JR	LODDE
 LDDY2	INC	HL
 	LD	E,(HL)
 	INC	HL
 	LD	D,(HL)
 	INC	HL
 	LD	(TEMP0),DE
