U5     ; U5/ASM
 SCOPY	LD	A,2
 	LD	(FMTYPE),A
 	XOR	A
 	LD	(STARTTRK),A
 	RST	8
 	DB	10,'Source.',0
 	CALL	ONEDRIVE
 	LD	A,(DRIV)	;get the drive
 	LD	(SDRIVE),A	;save it
 	RST	8
 	DB	10,'Destination.',0
 	CALL	GETDRIVES	;can use all 4
 	RST	8
 	DB	10,0
 	XOR	A
 	LD	(POSA),A	;start position
 	DEC	A
 	LD	(MFLAG),A
 	LD	A,(SDRIVE)
 	LD	HL,TYPEB
 	ADD	A,L
 	LD	L,A
 	LD	A,(HL)
 	AND	8
 	JR	Z,ASKIFFMT
 	XOR	A
 	LD	(MFLAG),A
 ASKIFFMT	RST	8
 	DB	1EH,'Format Drives ? ',0
 	XOR	A
 	LD	(SKVER),A
 	LD	(HASDATFLG),A
 	INC	A
 	LD	(IFBFMT),A
 	LD	B,3
 	RST	10H
 	JR	Z,SCOPYOLOOP
 	CALL	POSHL
 	JR	C,SCOPYOLOOP
 AKBAK	CALL	POSHL
 	JR	C,ANOBAK
 	CALL	UCASE
 	CP	'*'
 	JR	Z,BAKVERSKP
 	CP	'!'
 	JR	Z,BAKFMTSK
 	CP	'Y'
 	JR	Z,BAKFMT0
 	CP	'N'
 	JR	Z,BAKFMT1
 	JR	ASKIFFMT
 BAKVERSKP	LD	A,1
 	LD	(SKVER),A
 BAKVGO	INC	HL
 	JR	AKBAK
 BAKFMTSK	LD	A,1
 	LD	(HASDATFLG),A
 BAKFMT0	LD	A,1
 	LD	(IFBFMT),A
 	JR	BAKVGO
 BAKFMT1	XOR	A
 	JR	BAKFMT0+2
 ANOBAK	LD	A,0
 IFBFMT	EQU	$-1
 	DEC	A
 	JR	NZ,SCOPYBAK
 SCOPYOLOOP	RST	8
 	DB	10,'Mount DESTINATION diskettes. ',0
 	CALL	ONEKEY
 	RST	8
 	DB	10,0
 	LD	DE,SCOPYO
 	LD	BC,SCOPYBAK	;return here
 	JP	DRVCOMM		;do all dest drives
 SCOPYO	CALL	DSTAT		;is drive ready?
 	RET	NZ
 	JP	C,REMDRIVE
 	CALL	RESTORE
 	RET	NZ
 	JP	FORMIT		;format it
 SCOPYBAK	LD	A,(SDRIVE)
 	CALL	SETDRV
 	LD	BC,SCOPYI
 	PUSH	BC
 	PUSH	BC
 	JP	CNTOTAL
 SCOPYI	LD	(TEMP2),HL
 	LD	HL,0
 	OR	A
 	CALL	GETTYPEA
 	BIT	2,A
 	JR	Z,HAPZ
 	LD	L,1
 HAPZ	LD	(TEMP0),HL
 	CALL	INITBAD1
 	RST	8
 	DB	10,0
 SCOPYLP	LD	HL,TYPEB
 	LD	BC,0400H
 SCOPYCK	LD	A,(HL)
 	AND	8
 	JP	NZ,SCOPYCK0
 	INC	HL
 	DJNZ	SCOPYCK
 	RST	8
 	DB	10,'No Destination Drives !',0
 	JP	GOBACK
 SCOPYCK0	LD	HL,TYPEB
 	LD	A,(SDRIVE)
 	ADD	A,L
 	LD	L,A
 	LD	A,(HL)
 	BIT	3,A
 	LD	A,(SDRIVE)
 	JR	Z,MSTMNT
 	INC	A
 MSTMNT	LD	(DDRIVE),A
 	LD	DE,(TEMP0)
 	LD	(TEMP1),DE
 	LD	HL,(TEMP2)
 	LD	BC,GATBUFF
 	LD	A,(SDRIVE)
 	CALL	SETDRV
 	CALL	DRVSAME
 	CALL	Z,SMOUNT
 	PUSH	HL
 	CALL	MREAD
 	LD	(TEMP2),HL
 	LD	(TEMP0),DE
 	LD	B,H
 	LD	C,L
 	POP	HL
 	OR	A
 	SBC	HL,BC
 	LD	(TEMP3),HL
 	LD	DE,CPLP1
 	LD	BC,CPLP2
 	JP	DRVCOMM
 CPLP1	LD	A,(DRIV)
 	LD	(DDRIVE),A
 	CALL	DRVSAME
 	CALL	Z,DMOUNT
 	LD	HL,(TEMP3)
 	LD	DE,(TEMP1)
 	LD	BC,GATBUFF
 	CALL	DSTAT
 	RET	NZ
 	JR	C,REMDRIVE
 	CALL	MWRITE
 	JR	CPYVER
 REMDRIVE	LD	A,(DRIV)
 	LD	HL,TYPEB
 	ADD	A,L
 	LD	L,A
 	RES	3,(HL)
 	RET
 CPYVER	LD	A,0
 SKVER	EQU	$-1
 	DEC	A
 	RET	Z
 	LD	HL,(TEMP3)
 	LD	DE,(TEMP1)
 	LD	BC,GATBUFF
 	LD	(TEMP9),BC
 CPYVER1	PUSH	HL
 	LD	BC,DAMBUFF
 	CALL	SHOVERIFY
 	POP	HL
 ;	JR	C,REMDRIVE
 	PUSH	HL
 	LD	HL,(TEMP9)
 	PUSH	DE
 	LD	DE,DAMBUFF
 	LD	B,0
 	CALL	COMPARE
 	CALL	NZ,NOGOODV
 	LD	HL,(TEMP9)
 	INC	H
 	LD	(TEMP9),HL
 	POP	DE
 	POP	HL
 	CALL	NEXSEC
 	DEC	HL
 	LD	A,H
 	OR	L
 	JR	NZ,CPYVER1
 	RET
 CPLP2	LD	HL,(TEMP2)
 	LD	A,H
 	OR	L
 	JP	NZ,SCOPYLP
 	LD	DE,CPLPX
 	LD	BC,CPLPY
 	JP	DRVCOMM
 CPLPX	LD	DE,(TEMP0)
 	CALL	NEXSEC
 	RET	C
 	CALL	RETSEC
 CPLPZ	LD	BC,BUFFER
 	CALL	SHOVERIFY
 ;	RET	C
 	CALL	NEXSEC
 	JR	NC,CPLPZ
 UPDIRX	OR	A
 	CALL	GETTKS
 	RST	18H
 	LD	(UPDIRY),A
 	LD	(UPDIRY+1),BC
 	RST	8
 	DB	10,'Updating Directory to '
 UPDIRY	DB	'xxx Tracks.',10,0
 	CALL	RDDIR
 	JR	Z,UPDIRZ
 	JR	C,UPDIRZ
 	CALL	MAKEGAT+3
 	JP	WRDIR
 UPDIRZ	RST	8
 	DB	1EH,'Cannot Update Directory !',10,0
 	RET
 CPLPY	RST	8
 	DB	10,0
 	JP	SFMT4
 UCOPY	RST	8
 	DB	10,0
 	CALL	ONEDRIVE
 	LD	A,(DRIV)
 	LD	(SDRIVE),A
 	OR	A
 	CALL	GETTKS
 	LD	(TEMP3),A
 	RST	18H
 	LD	(TOTTRK),A
 	LD	(TOTTRK+1),BC
 	RST	8
 	DB	10,0
 	LD	IX,DAMBUFF
 	PUSH	IX
 	POP	IY
 	CALL	DRVASC
 	LD	(MNYDRV),A
 	CALL	DSTAT
 	JP	NZ,GOBACK
 	CALL	RESTORE
 	JP	NZ,GOBACK
 	XOR	A
 	LD	(TEMP0),A
 	LD	(TASKDRV),A
 UTLOOP	OR	A
 	CALL	GETTYPEA
 	BIT	7,A
 	RES	7,(IY)
 	JR	Z,UTLOOP11
 	SET	7,(IY)
 UTLOOP11	PUSH	IX
 	POP	IY
 	LD	(IY),0
 	INC	IX
 	LD	A,(TEMP0)
 	RST	18H
 	LD	(MNYTRK),A
 	LD	(MNYTRK+1),BC
 COTTNXX	LD	A,50
 	LD	(TEMP1),A
 COTTN	LD	A,(3840H)	;check for u arrow
 	AND	8
 	JP	NZ,ADVTRKK
 	CALL	CKADDR
 	JR	C,ALSKDJ
 	JR	Z,ALSKDJ
 	JR	UT0LOOP
 ALSKDJ	CALL	CKADDR
 	JP	Z,ADVTRKK
 	JP	C,ADVTRKK
 UT0LOOP	LD	A,(3840H)
 	BIT	1,A
 	JR	NZ,UT0LOOP
 	CALL	IFTHER
 	JR	NZ,COTTN0
 	LD	A,(TEMP1)
 	DEC	A
 	LD	(TEMP1),A
 	JR	NZ,COTTN
 	JP	ADVTRKK
 COTTN0	LD	HL,INPUT
 	LD	B,4
 PUTNLP	LD	A,(HL)
 	LD	(IX),A
 	INC	HL
 	INC	IX
 	DJNZ	PUTNLP
 	LD	A,(INPUT)
 	LD	D,A
 ;i*
 	IF	MODI
 	LD	(37EDH),A
 	ENDIF
 ;iii*
 	IF	MODIII
 	OUT	(0F1H),A
 	ENDIF
 ;
 	LD	A,(INPUT+2)
 	LD	E,A
 	LD	BC,FBUFF
 	CALL	COMPDATA
 	LD	(RDTYPE),A
 	CALL	READNS
 	EX	AF,AF'
 	LD	(IX),A
 	LD	A,(RESULT)
 	BIT	3,A
 	JR	Z,QPBN
 	RES	3,(IX)
 QPBN	INC	IX
 	INC	(IY)
 	CALL	SHOMNY
 	JP	COTTNXX
 	CALL	SHOMNY
 ADVTRKK	LD	A,(3840H)
 	BIT	7,A
 	JP	NZ,COTTN
 	LD	A,(TEMP0)
 	INC	A
 	LD	(TEMP0),A
 	LD	B,A
 	OR	A
 	CALL	GETTKS
 	CP	B
 	JP	Z,GOGOCOPY
 	CALL	STEPIN
 	JP	UTLOOP
 SHOMNY	LD	A,(IY)
 	AND	7FH
 	RST	18H
 	LD	(MNYSEC),A
 	LD	(MNYSEC+1),BC
 	LD	A,(INPUT)
 	RST	18H
 	LD	(NEWTRK),A
 	LD	(NEWTRK+1),BC
 	LD	A,(INPUT+1)
 	RST	18H
 	LD	(NEWHED),A
 	LD	(NEWHED+1),BC
 	LD	A,(INPUT+2)
 	RST	18H
 	LD	(NEWSEC),A
 	LD	(NEWSEC+1),BC
 	LD	A,(INPUT+3)
 	RST	18H
 	LD	(NEWLEN),A
 	LD	(NEWLEN+1),BC
 	EX	AF,AF'
 	PUSH	AF
 	LD	A,(RESULT)
 	BIT	3,A
 	LD	A,20H
 	LD	BC,2020H
 	JR	Z,HAVBBM
 	LD	A,'N'
 	LD	BC,4E4FH
 HAVBBM	LD	(NEWIBM),A
 	LD	(NEWIBM+1),BC
 	POP	AF
 	AND	3
 	LD	E,'S'
 	LD	BC,4454H
 	JR	Z,HAVTYPOF
 	CP	1
 	LD	E,'R'
 	LD	BC,5450H
 	JR	Z,HAVTYPOF
 	CP	2
 	LD	E,'D'
 	LD	BC,5444H
 	JR	Z,HAVTYPOF
 	LD	E,'U'
 	LD	BC,4644H
 HAVTYPOF	LD	A,E
 	LD	(NEWTYPE),A
 	LD	(NEWTYPE+1),BC
 	CALL	DLOFF
 	RST	8
 	DB	1DH,'Drive '
 MNYDRV	DB	'x, Tracks = '
 TOTTRK	DB	'xxx.  On Track '
 MNYTRK	DB	'xxx, Found '
 MNYSEC	DB	'xxx Sectors.',10
 	DB	'Track '
 NEWTRK	DB	'xxx, Head '
 NEWHED	DB	'xxx, Sector '
 NEWSEC	DB	'xxx, Length '
 NEWLEN 	DB	'xxx, '
 NEWIBM	DB	'xxx IBM, '
 NEWTYPE	DB	'xxx.',11,0
 	JP	DLON
 IFTHER	LD	A,(IY)
 	AND	7FH
 	JR	NZ,IFCON
 	OR	1
 	RET
 IFCON	LD	C,A
 	PUSH	IY
 	POP	DE
 	INC	DE
 IFCLP	LD	HL,INPUT
 	LD	B,4
 IFLL	LD	A,(DE)
 	CP	(HL)
 	JR	NZ,NEXIF
 	INC	HL
 	INC	DE
 	DJNZ	IFLL
 	RET
 NEXIF	INC	DE
 	DJNZ	NEXIF
 	INC	DE
 	DEC	C
 	JR	NZ,IFCLP
 	OR	1
 	RET
 GOGOCOPY	PUSH	IX
 	POP	HL
 	INC	H
 	LD	L,0
 	LD	(FMTBUFF),HL
 	RST	8
 	DB	10,10,'Destination.',0
 	CALL	ONEDRIVE
 	LD	A,(TEMP3)
 	SCF
 	CALL	GETTKS
 	RST	8
 	DB	10,0
 	LD	A,(DRIV)
 	LD	(DDRIVE),A
 	CALL	DRVSAME
 	CALL	Z,MOUNTDES
 	CALL	DSTAT
 	JP	NZ,GOBACK
 	CALL	RESTORE
 	JP	NZ,GOBACK
 	XOR	A
 	LD	(TEMP0),A
 	LD	IY,DAMBUFF
 TTKKLP	PUSH	IY
 	POP	IX
 	INC	IY
 	LD	A,(IX)
 	AND	7FH
 	JP	Z,ADVTTK
 	OR	A
 	CALL	GETTYPEA
 	RES	7,A
 	BIT	7,(IX)
 	JR	Z,TYUIC
 	SET	7,A
 	SET	3,A
 TYUIC	SCF
 	CALL	GETTYPEA
 	BIT	7,(IX)
 	LD	HL,(FMTBUFF)
 	PUSH	AF
 	CALL	CLRBUFF
 	POP	AF
 	JP	Z,FILSNG
 	LD	B,3EH
 	LD	A,4EH
 	CALL	FILL
 	LD	A,(IX)
 	AND	7FH
 	LD	B,A
 SSLP1	PUSH	BC
 	LD	B,0CH
 	XOR	A
 	CALL	FILL
 	LD	B,3
 	LD	A,0F5H
 	CALL	FILL
 	LD	(HL),0FEH
 	INC	HL
 	LD	B,4
 SSLP2	LD	A,(IY)
 	INC	IY
 	LD	(HL),A
 	INC	HL
 	DJNZ	SSLP2
 	LD	(HL),0F7H
 	INC	HL
 	LD	A,4EH
 	LD	B,16H
 	CALL	FILL
 	XOR	A
 	LD	B,0CH
 	CALL	FILL
 	LD	A,0F5H
 	LD	B,3
 	CALL	FILL
 	LD	A,(IY)
 	AND	3
 	XOR	3
 	OR	0F8H
 	LD	(HL),A
 	INC	HL
 	CALL	FILLDAT0
 	LD	(HL),0F7H
 	INC	HL
 	LD	A,4EH
 	LD	B,16H
 	CALL	FILL
 	POP	BC
 	DJNZ	SSLP1
 DBLRET	LD	BC,(FMTBUFF)
 	CALL	SHOFMT
 	JP	NZ,GOBACK
 ADVTTK	LD	A,(TEMP0)
 	INC	A
 	LD	(TEMP0),A
 	LD	B,A
 	OR	A
 	CALL	GETTKS
 	CP	B
 	JP	Z,PERCPPY
 	CALL	STEPIN
 	JP	TTKKLP
 FILSNG	LD	B,1FH
 	LD	A,-1
 	CALL	FILL
 	LD	A,(IX)
 	AND	7FH
 	LD	B,A
 SSLP3	PUSH	BC
 	LD	B,6
 	XOR	A
 	CALL	FILL
 	LD	(HL),0FEH
 	INC	HL
 	LD	B,4
 SSLP4	LD	A,(IY)
 	INC	IY
 	LD	(HL),A
 	INC	HL
 	DJNZ	SSLP4
 	LD	(HL),0F7H
 	INC	HL
 	LD	B,0BH
 	LD	A,-1
 	CALL	FILL
 	LD	B,6
 	XOR	A
 	CALL	FILL
 	LD	A,(IY)
 	AND	3
 	XOR	3
 	OR	0F8H
 	LD	(HL),A
 	INC	HL
 	CALL	FILLDAT0
 	LD	(HL),0F7H
 	INC	HL
 	LD	B,0BH
 	LD	A,-1
 	CALL	FILL
 	POP	BC
 	DJNZ	SSLP3
 	LD	B,0BH
 	CALL	FILL
 	JP	DBLRET
 FILLDAT0	LD	A,(IY-1)
 	BIT	3,(IY)
 	INC	IY
 	JR	Z,NONIBM0
 	OR	A
 	LD	BC,128
 	JR	Z,GOTTT08
 	CALL	BY256
 	JR	GOTTT08
 NONIBM0	CALL	S8S8
 GOTTT08	PUSH	HL		;save HL
 	ADD	HL,BC		;check for mem overflow
 	POP	HL
 	RET	C
 GOTTT0	LD	(HL),0
 	INC	HL
 	DEC	BC
 	LD	A,B
 	OR	C
 	JR	NZ,GOTTT0
 	RET
 BY256	LD	DE,256
 	JR	MULT0
 S8S8	LD	DE,16
 MULT0	LD	B,A
 	PUSH	HL
 	LD	HL,0
 MULP0	SRL	B
 	JR	NC,MULPC
 	ADD	HL,DE
 MULPC	JR	Z,MULDD
 	EX	DE,HL
 	ADD	HL,HL
 	EX	DE,HL
 	JR	MULP0
 MULDD	LD	B,H
 	LD	C,L
 	POP	HL
 	RET
 PERCPPY	RST	8
 	DB	10,'Copying.',10,0
 	LD	IY,DAMBUFF
 	XOR	A
 	LD	(TEMP0),A
 SNGRD	PUSH	IY
 	POP	IX
 	LD	A,(SDRIVE)
 	CALL	SETDRV
 	CALL	DRVSAME
 	CALL	Z,MOUNTSRC
 	LD	BC,(FMTBUFF)
 	LD	A,(TEMP0)
 	OR	A
 	JR	NZ,SRDLP
 	CALL	RESTORE
 	JP	NZ,GOBACK
 SRDLP	LD	A,(IY)
 	AND	7FH
 	LD	(TEMP4),A
 	OR	A
 	CALL	GETTYPEA
 	RES	7,A
 	BIT	7,(IY)
 	INC	IY
 	JR	Z,PUPUL
 	SET	7,A
 	SET	3,A
 PUPUL	SCF
 	CALL	GETTYPEA
 SSLP	LD	D,(IY)
 	INC	IY
 	INC	IY
 	LD	E,(IY)
 	INC	IY
 	INC	IY
 	LD	A,(IY)
 	INC	IY
 	AND	8
 	OR	80H
 	LD	(RDTYPE),A
 	LD	A,D
 ;i*
 	IF	MODI
 	LD	(37EDH),A
 	ENDIF
 ;iii*
 	IF	MODIII
 	OUT	(0F1H),A
 	ENDIF
 ;
 	RST	8
 	DB	1DH,'Reading ',0
 	CALL	SHOWWH
 	CALL	READNS
 	JR	Z,UAIS
 	INC	B
 UAIS	LD	A,(TEMP4)
 	DEC	A
 	LD	(TEMP4),A
 	JR	NZ,SSLP
 	CALL	DRVSAME
 	CALL	NZ,STEPIN
 	LD	A,(DDRIVE)
 	CALL	SETDRV
 	CALL	DRVSAME
 	CALL	Z,MOUNTDES
 	LD	BC,(FMTBUFF)
 	LD	A,(TEMP0)
 	OR	A
 	JR	NZ,SWDLP
 	CALL	RESTORE
 	JP	NZ,GOBACK
 SWDLP	LD	A,(IX)
 	AND	7FH
 	LD	(TEMP4),A
 	OR	A
 	CALL	GETTYPEA
 	RES	7,A
 	BIT	7,(IX)
 	INC	IX
 	JR	Z,HGFDA
 	SET	7,A
 	SET	3,A
 HGFDA	SCF
 	CALL	GETTYPEA
 SWLP	LD	D,(IX)
 	INC	IX
 	INC	IX
 	LD	E,(IX)
 	INC	IX
 	INC	IX
 	LD	A,D
 ;i*
 	IF	MODI
 	LD	(37EDH),A
 	ENDIF
 ;iii*
 	IF	MODIII
 	OUT	(0F1H),A
 	ENDIF
 ;
 	LD	A,(IX)
 	INC	IX
 	LD	(WRTYPE),A
 	RST	8
 	DB	1DH,'Writing ',0
 	CALL	SHOWWH
 	CALL	WRITENS
 	JR	Z,UIIHA
 	INC	B
 UIIHA	LD	A,(TEMP4)
 	DEC	A
 	LD	(TEMP4),A
 	JR	NZ,SWLP
 	CALL	STEPIN
 	LD	A,(TEMP0)
 	INC	A
 	LD	(TEMP0),A
 	LD	E,A
 	OR	A
 	CALL	GETTKS
 	CP	E
 	JP	NZ,SNGRD
 	RST	8
 	DB	10,0
 ALLDON0	RST	8
 	DB	1EH,'Another Copy ? ',0
 	LD	B,3
 	RST	10H
 	JR	Z,ALLDON0
 	CALL	UCASE
 	CP	'N'
 	JP	Z,GOBACK
 	CP	'Y'
 	JR	NZ,ALLDON0
 	JP	GOGOCOPY
 COMPPASS	RST	8
 	DB	10,0
 COMPP1	RST	8
 	DB	1EH,'E>ncode or D>ecode ? ',0
 	LD	B,1
 	RST	10H
 	JR	Z,COMENC
 	CALL	UCASE
 	CP	'D'
 	JP	Z,COMDEC
 	CP	'E'
 	JR	NZ,COMPP1
 COMENC	RST	8
 	DB	10,'Password ? ',0
 	LD	B,8
 	RST	10H
 	CALL	CODE
 	LD	A,L
 	RST	20H
 	LD	(COMPW),BC
 	LD	A,H
 	RST	20H
 	LD	(COMPW+2),BC
 	RST	8
 	DB	10,'Encoded = '
 COMPW	DB	'xxxxH.',0
 	JP	GOBACK
 COMDEC	RST	8
 	DB	10,0
 	CALL	ASKFILE
 	CALL	MOVEFILE
 	CALL	C,BADFILE
 	JR	C,COMDEC
 	CALL	FINDFILE
 	CALL	C,NOFILE
 	JR	C,COMDEC
 	RST	8
 	DB	10,0
 	LD	HL,(CURSOR)
 	PUSH	IX
 	CALL	SHOWIT
 	POP	IX
 	LD	E,(IX+16)
 	LD	D,(IX+17)
 	LD	A,E
 	RST	20H
 	LD	(ACC1),BC
 	LD	A,D
 	RST	20H
 	LD	(ACC1+2),BC
 	RST	8
 	DB	10,'Access   = '
 ACC1	DB	'xxxxH.',10,0
 	DI
 	CALL	FIGPASS
 	EI
 WTTC	CALL	IFCLEAR
 	JR	C,WTTC
 	LD	E,(IX+18)
 	LD	D,(IX+19)
 	LD	A,E
 	RST	20H
 	LD	(ACC2),BC
 	LD	A,D
 	RST	20H
 	LD	(ACC2+2),BC
 	RST	8
 	DB	10,'Update   = '
 ACC2	DB	'xxxxH.',10,0
 	DI
 	CALL	FIGPASS
 	EI
 	JP	GOBACK
 FIGPGOT	LD	A,E
 	RST	20H
 	LD	(DUMPU),BC
 	LD	A,D
 	RST	20H
 	LD	(DUMPU+2),BC
 	RST	8
 	DB	1DH
 DUMPASS	DB	'xxxxxxxx = '
 DUMPU	DB	'xxxxH.',0
 	RET
 FIGPASS	LD	HL,DUMPASS
 	LD	B,8
 	LD	A,20H
 	CALL	FILL
 	LD	BC,(CURSOR)
 	LD	A,99H
 	LD	(BC),A
 FIGPSLP	LD	HL,DUMPASS
 	PUSH	DE
 	LD	B,8
 	CALL	CODE
 	POP	DE
 	OR	A
 	SBC	HL,DE
 	JR	Z,FIGPGOT
 	CALL	IFCLEAR
 	RET	C
 	LD	HL,DUMPASS
 	LD	A,(HL)
 	CP	20H
 	CALL	Z,DUMP5
 	INC	A
 	CP	5BH
 	JR	NZ,DUMP44
 	LD	(HL),'A'
 	INC	HL
 	LD	BC,(CURSOR)
 	LD	A,(BC)
 	XOR	3FH
 	LD	(BC),A
 DUMP1	LD	A,(HL)
 	CP	20H
 	CALL	Z,DUMP6
 	INC	A
 	CP	3AH
 	JR	Z,DUMP2
 	CP	5BH
 	JR	Z,DUMP3
 DUMP44	LD	(HL),A
 DUMP4	JR	FIGPSLP
 DUMP2	LD	A,'A'
 	JR	DUMP44
 DUMP3	LD	(HL),'0'
 	INC	HL
 	LD	A,(HL)
 	CP	20H
 	CALL	Z,DUMP6
 	LD	(HL),A
 	JR	DUMP1
 DUMP5	LD	A,40H
 	RET
 DUMP6	LD	A,2FH
 	RET
 NOGOODV	RST	8
 	DB	'  ** BAD **',10,0
 	RET
R	DUMP44
 DUMP3	LD	(HL),'0'
 	INC	HL
 	LD	A,(HL)
 	CP	20H
 	CALL	Z,DUMP6
 	LD	(HL),A
 	JR	DUMP1
 DUMP5	LD	A,40H
 	RET
 DUMP6	LD	A,2FH
