UK3    ;uk3/asm
 BT3BUFF	EQU	4D00H
 BT3NMIRET	EQU	43C9H
 BT3ERROR	EQU	43E9H
 BT3GET1B	EQU	435AH
 BT3GETBT3LOAD	EQU	4336H
 BT3READ	EQU	4376H
 BT3SEL	EQU	4355H
 BT3SEEK	EQU	43D2H
 BT3SETNMI	EQU	439BH
 BT3SLOW	EQU	43CBH
 BT3SSAV	EQU	43B3H
 BT3BFSAV	EQU	43BCH
 BT3RETNMI	EQU	43B1H
 BT3MSG	EQU	43F3H
 KIMBOOT3	CP	17
 	DI
 	LD	HL,BT3NMIRET
 	LD	(404AH),HL
 	LD	A,0C3H
 	LD	(4049H),A
 	LD	DE,4
 	LD	L,-1
 	EXX
 BT3LOOP	CALL	BT3GET1B
 	CP	1
 	JR	Z,BT3LOAD
 	CP	2
 	JR	Z,BT3START
 	CP	20H
 	JP	NC,BT3ERROR
 	CALL	BT3GET1B
 	LD	B,A
 BT3LOOP2	CALL	BT3GET1B
 	DJNZ	BT3LOOP2
 	JR	BT3LOOP
 BT3START	CALL	BT3GET1B
 	CALL	BT3GETBT3LOAD
 	JP	(HL)
 	CALL	BT3GET1B
 	LD	L,A
 	CALL	BT3GET1B
 	LD	H,A
 	RET
 BT3LOAD	CALL	BT3GET1B
 	LD	B,A
 	CALL	BT3GETBT3LOAD
 	DEC	B
 	DEC	B
 BT3LOAD2	CALL	BT3GET1B
 	LD	(HL),A
 	CP	(HL)
 	JP	NZ,BT3ERROR
 	INC	HL
 	DJNZ	BT3LOAD2
 	JR	BT3LOOP		;go again
 	LD	A,81H
 	OUT	(0F4H),A
 	RET
 	EXX
 	INC	L
 	JR	NZ,BT3HAV1B
 	LD	HL,BT3BUFF
 	CALL	BT3READ
 	CALL	NZ,BT3READ
 	JP	NZ,BT3ERROR
 	INC	E
 	LD	A,E
 	SUB	19
 	JR	NZ,BT3HAV1B
 	LD	E,1
 	INC	D
 BT3HAV1B	LD	A,(HL)
 	EXX
 	RET
 	CALL	BT3SEL
 	CALL	BT3SEEK
 	CALL	BT3SETNMI
 	LD	A,80H
 	OUT	(0F0H),A
 	CALL	BT3SLOW
 	LD	A,0C0H
 	OUT	(0E4H),A
 BT3READ1	IN	A,(0F0H)
 	AND	E
 	JR	Z,BT3READ1
 	INI
 	LD	A,0C1H
 BT3READ2	OUT	(0F4H),A
 	INI
 	JR	NZ,BT3READ2
 	JR	$
 	LD	(BT3SSAV),DE
 	LD	(BT3BFSAV),HL
 	LD	DE,BT3RETNMI
 	LD	(404AH),DE
 	LD	BC,0F3H
 	LD	E,2
 	IN	A,(0F0H)
 	RET
 	POP	HL
 	LD	DE,0
 	LD	HL,BT3NMIRET
 	LD	(404AH),HL
 	LD	HL,0
 	XOR	A
 	OUT	(0E4H),A
 	CALL	BT3SLOW
 	IN	A,(0F0H)
 	AND	9FH
 	RET
 	RETN
 	PUSH	BC
 	LD	B,12
 	DJNZ	$
 	POP	BC
 	RET
 	LD	A,D
 	OUT	(0F3H),A
 	CALL	BT3SEL
 	LD	A,1BH
 	OUT	(0F0H),A
 	CALL	BT3SLOW
 BT3SEEKWT	IN	A,(0F0H)
 	BIT	0,A
 	JR	NZ,BT3SEEKWT
 BT3SEEKOK	LD	A,E
 	OUT	(0F2H),A
 	RET
 	LD	HL,BT3MSG
 	CALL	21BH
 	CALL	40H
 	RST	0
 	DB	1CH,1FH,'* Error * ',3
 	OUT	(0F0H),A
 	CALL	BT3